package code;

import heap.Heap;

import java.util.Map;

import output.FileOutput;

public class CNAnd extends CodeNode implements Expression {

	public CNAnd(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			if(n.typeCheck(types) != BOOLEAN)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = BOOLEAN;
		return BOOLEAN;
	}
	


	public String out(FileOutput module) {
		String s = new String();
		s = ((CodeNode)this.jjtGetChild(0)).out(module);		
		for(int i = 1;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			s += module.and() + n.out(module);
		}
		return s;
	}

	public int evaluate(Heap h) {
		if(!isPure())
			return double_;
		else
		{
			for(int i = 0;i < this.jjtGetNumChildren();i++)
			{
				Expression e = (Expression)this.jjtGetChild(i);
				if(e.evaluate(h) == false_)
					return false_;
			}
			return true_;
		}
	}

	public boolean isPure() {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			Expression e = (Expression)this.jjtGetChild(i);
			if(!e.isPure())
			{
				return false;
			}
		}
		return true;
	}
}
