package code;

import heap.*;

import java.util.Map;

import output.FileOutput;

public class CNEq extends CodeNode implements Expression{
		
	public CNEq(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		int t = UNCHECKED;
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			if(i == 0)
			{
				t = n.typeCheck(types);
				if(t == UNCHECKED)
				{
					this.type = UNCHECKED;
					return UNCHECKED;
				}
			}
			else if(n.typeCheck(types) != t)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = BOOLEAN;
		return BOOLEAN;
	}

	public String out(FileOutput module) {
		String s = new String();
		s = ((CodeNode)this.jjtGetChild(0)).out(module);		
		for(int i = 1;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			s += module.eq() + n.out(module);
		}
		return s;
	}
	
	public int evaluate(Heap h) {
		if(!isPure())
			return double_;
		else
		{
			// plusieurs cas possibles : soit on compare deux booleens soit deux valeurs pointeurs
			if(((CodeNode)this.jjtGetChild(0)).type() == BOOLEAN)
			{
				Expression e1 = (Expression)this.jjtGetChild(0);
				Expression e2 = (Expression)this.jjtGetChild(1);
				if(e1.evaluate(h) == e2.evaluate(h))
					return true_;
				else
					return false_;
			}
			else
			{
				if((CodeNode)this.jjtGetChild(0) instanceof CNId)
				{
					if(((CNId)this.jjtGetChild(0)).next())
					{
						return double_; // we can't evaluate the value of the counter
					}
					else
					{
						if((CodeNode)this.jjtGetChild(1) instanceof CNId)
						{
							if(((CNId)this.jjtGetChild(1)).next())
								return double_;
							else
							{
								Root r1 = new Root(((CNId)this.jjtGetChild(0)).name());
								Root r2 = new Root(((CNId)this.jjtGetChild(1)).name());
								Vertex v1 = h.getVertex(r1);
								if(v1 == null)
									return (h.getVertex(r2) == null)?true_:false_;
								else
									return (v1.equals(h.getVertex(r2))?true_:false_);
								
							}
						}
						else if((CodeNode)this.jjtGetChild(1) instanceof CNNull)
						{
							Root r1 = new Root(((CNId)this.jjtGetChild(0)).name());
							Vertex v1 = h.getVertex(r1);
							if(v1 == null)
								return true_;
							else
								return false_;
						}
						else
							throw new RuntimeException("Expression is not valid");
					}
				}
				else if((CodeNode)this.jjtGetChild(0) instanceof CNNull)
				{
					if((CodeNode)this.jjtGetChild(1) instanceof CNId)
					{
						if(((CNId)this.jjtGetChild(1)).next())
							return double_;
						else
						{
							Root r2 = new Root(((CNId)this.jjtGetChild(1)).name());
							Vertex v2 = h.getVertex(r2);
							if(v2 == null)
								return true_;
							else
								return false_;
							
						}
					}
					else if((CodeNode)this.jjtGetChild(1) instanceof CNNull)
					{
						return true_;
					}
					else
						throw new RuntimeException("Expression is not valid");
				}
				else
					throw new RuntimeException("Expression is not valid");
			}
		}
	}

	public boolean isPure() {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			Expression e = (Expression)this.jjtGetChild(i);
			if(!e.isPure())
			{
				return false;
			}
		}
		return true;
	}
}
