package code;

import heap.Heap;

import java.util.Map;

import output.FileOutput;

public class CNGt extends CodeNode implements Expression {

	public CNGt(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			if(n.typeCheck(types) != INTEGER)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = BOOLEAN;
		return BOOLEAN;
	}

	public String out(FileOutput module) {
		String s = new String();
		s = ((CodeNode)this.jjtGetChild(0)).out(module);		
		for(int i = 1;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			s += module.gt() + n.out(module);
		}
		return s;
	}
	
	public int evaluate(Heap h) {
		return double_;
	}

	public boolean isPure() {
		return false;
	}
}
