package code;

import heap.Heap;
import java.util.*;

import output.FileOutput;

public class CNIf extends CodeNode  implements Statement{
	private Statement nexttrue;
	private Statement nextfalse;
	
	public CNIf(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		if(((CodeNode)this.jjtGetChild(0)).typeCheck(types) != BOOLEAN)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}
		if(((CodeNode)this.jjtGetChild(1)).typeCheck(types) != STATEMENT)
		{
			this.type = UNCHECKED;
			return UNCHECKED;
		}
		if(this.jjtGetNumChildren() == 3)
		{
			if(((CodeNode)this.jjtGetChild(2)).typeCheck(types) != STATEMENT)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = STATEMENT;
		return STATEMENT;		
	}

	public Statement next()
	{
		return nexttrue;
	}
	
	public Statement next(boolean guard)
	{
		return guard?nexttrue:nextfalse;
	}
	
	public void setNext(Statement s)
	{
		nexttrue = (Statement)this.jjtGetChild(1);
		nexttrue.setNext(s);
		if(this.jjtGetNumChildren() == 3)
		{
			nextfalse = (Statement)this.jjtGetChild(2);
			nextfalse.setNext(s);
		}
		else
		{
			nextfalse = s;
		}		
	}
	
	public int instruction(Heap h)
	{
		return if_;
	}
	
	public int next(Heap h)
	{
		Expression e = (Expression)this.jjtGetChild(0);
		if(e.isPure())
		{
			if(e.evaluate(h) == Expression.true_)
				return true_;
			else
				return false_;
		}
		else
			return double_;
	}

	public String out(FileOutput module) {
		return "";
	}
	
	
	
	
}
