package code;

import heap.Heap;

import java.util.Map;

import output.FileOutput;

public class CNNot extends CodeNode implements Expression{

	public CNNot(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			if(n.typeCheck(types) != BOOLEAN)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = BOOLEAN;
		return BOOLEAN;
	}

	public String out(FileOutput module) {
		String s = new String();
		if(module.supportSwitch())
		{
			module.switchNot();
			s = ((CodeNode)this.jjtGetChild(0)).out(module);		
			module.switchNot();
		}
		else
		{
			s = module.not() + module.leftP() + ((CodeNode)this.jjtGetChild(0)).out(module) + module.rightP();
		}
		return s;
	}
	
	public int evaluate(Heap h) {
		if(!isPure())
			return double_;
		else
		{
			Expression e = (Expression)this.jjtGetChild(0);
			if(e.evaluate(h) == true_)
					return false_;
			else
				return true_;			
		}
	}

	public boolean isPure() {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			Expression e = (Expression)this.jjtGetChild(i);
			if(!e.isPure())
			{
				return false;
			}
		}
		return true;
	}
}
