package code;
import heap.*;

import java.util.Map;

import output.FileOutput;

public class CNSList extends CodeNode  implements Statement{
	private Statement next;
	
	public CNSList(int i) {
		super(i);
	}

	public int typeCheck(Map types) {
		for(int i = 0;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			if(n.typeCheck(types) != STATEMENT)
			{
				this.type = UNCHECKED;
				return UNCHECKED;
			}
		}
		this.type = STATEMENT;
		return STATEMENT;
	}
	
	public Statement next()
	{
		return next;
	}
	
	public Statement next(boolean guard)
	{
		return next;
	}
	
	public void setNext(Statement s)
	{
		next = (Statement)this.jjtGetChild(0);
		for(int i = 0;i < this.jjtGetNumChildren()-1; i++)
		{
			((Statement)this.jjtGetChild(i)).setNext((Statement)this.jjtGetChild(i+1));
		}
		if(this.jjtGetNumChildren() != 0)
			((Statement)this.jjtGetChild(this.jjtGetNumChildren()-1)).setNext(s);
	}
	
	public int instruction(Heap h)
	{
		return slist_;
	}
	
	public int next(Heap h)
	{
		return true_;
	}
	
	public String out(FileOutput module) {
		String s = new String();
		s = ((CodeNode)this.jjtGetChild(0)).out(module);		
		for(int i = 1;i < this.jjtGetNumChildren();i++)
		{
			CodeNode n = (CodeNode)this.jjtGetChild(i);
			s += module.slist() + n.out(module);
		}
		return s;
	}
	
	
}
