package output;

import java.util.*;
import code.*;
import automaton.*;

import automaton.Automaton;

public class CaFile implements FileOutput {
	private java.io.PrintWriter file;
	private String name;
	
	public CaFile()
	{
		file = null;
		name = null;
	}
	
	public String add() {
		return " + ";
	}

	public String and() {
		return ", ";
	}

	public String asgn() {
		return " := ";
	}

	public void close() {
		file.flush();
		file.close();
	}

	public String eq() {
		return " = ";
	}

	public String ge() {
		return " >= ";
	}

	public String gt() {
		return " > ";
	}

	public String le() {
		return " <= ";
	}

	public String lt() {
		return " < ";
	}

	public String mult() {
		return " * ";
	}

	public String not() {
		return " ! ";
	}

	public void open(String name) throws java.io.FileNotFoundException {
		this.name = name;
		file = new java.io.PrintWriter(new java.io.FileOutputStream(name+".ca"));
	}
	
	public String filename(){
		return name+".ca";
	}

	public String or() {
		return " || ";
	}

	public String slist() {
		return " , ";
	}

	public String sub() {
		return " - ";
	}
	
	public String Null(){
		return " null ";
	}
	
	public String New(){
		return " new ";
	}

	public void write(Automaton a) {
		Iterator i = a.getTransitions().iterator();
		int j = 0;
		while(i.hasNext())
		{
			this.writeTransition((Transition)i.next());
			this.file.println();
		}
	}
	
	private void writeTransition(Transition t)
	{
		if(t.getSinitial().isError())
			this.file.print("h_error");
		else
			this.file.print("h_"+t.getSinitial().getId());		
		this.file.print(" -> ");
		if(t.getSfinal().isError())
			this.file.print("h_error");
		else
			this.file.print("h_"+t.getSfinal().getId()+"");
		this.file.print(" [" + this.writeGuard(t.getGuard())+"] ");
		this.file.print(" {" + this.writeActions(t.getActions())+"}");
	}
	
	private String writeGuard(CodeNode g)
	{
		if(g != null)
			return g.out(this);
		else
		    return "";
	}
	
	private String writeActions(CodeNode a)
	{
		if(a != null)
		        return a.out(this);
		else
		    return "";
	}
		
	public boolean pointerGuards()
	{
		return false;
	}
	
	public void switchNot(){
	}

	public String leftP() {
		return " ( ";
	}

	public String rightP() {
		return " ) ";
	}

	public boolean supportSwitch() {
		return false;
	}
}
